#ifndef NETOBJECT_H
#define NETOBJECT_H


#include "node.h"


/* public */


gpointer AddNodeVisual( Node* );
int DestroyingVisual( gpointer );
void RemoveNodeVisual( Node* );
gpointer AddLinkVisual( NetInfo* );
void RemoveLinkVisual( NetInfo* );
void StopDestroyingVisual( gpointer );
void BeginDestroyVisual( gpointer );


/* private */


#define NO_NODE 1
#define NO_LINK 2


typedef struct net_object
{       void (*DrawSelf)( struct net_object* self );
        float currentRed, currentGreen, currentBlue;
        float targetRed, targetGreen, targetBlue;
        float currentX, currentY, currentZ;
        float targetX, targetY, targetZ;
        char destroyed;
        char initialized;
        char atCoords;
        Node* nodeLink;
	NetInfo* netInfoLink;
	float lastWidth;
	GTree* sentLinkTree;
	GTree* receivedLinkTree;
	char type;
} NetObject;


void NetObjectProcessDestroyed();
void NetObjectDestroy( NetObject* );
void NetObjectSetDestroyed( NetObject* );
int NetObjectTimeDifference( NetObject* no );
int NetObjectLeaveCoords( NetObject* no );
int NetObjectDraw( gpointer unused1, NetObject* n, gpointer unused2 );
int NetObjectVertexDraw( gpointer unused1, NetInfo* ni, Node* n );
NetObject* NetObjectCreate( void (*draw)( NetObject* ) );
void NetObjectSetTargetColor( NetObject* no, float r, float g, float b );
void NetObjectSetTargetLighting( NetObject* no, float amount );
void NetObjectApproachColor( NetObject* no );
int NetObjectApproachCoords( NetObject* no );
NetObject* AddNetObject( NetObject* no );
int NetObjectDrawLink( gpointer unused, NetObject* no );
int NetObjectDraw( gpointer unused1, NetObject* no, gpointer unused2 );


#endif
