#ifndef STAT_H
#define STAT_H

#include <glib.h>
#include <sys/time.h>
#include <unistd.h>

#include "wired.h"

struct node;

typedef struct net_stat
{	ip addr[4];
	GTree* receivedFrom;
	GTree* sentTo;
	guint32 totalNumPackets;
	guint32 totalDataNew;
	guint32 totalData;
	guint32 snapTraffic;
	struct timeval lastPacket;
} NetStat;


typedef struct net_info
{	ip addr[4];
	struct node* nodeLink;
	struct node* myself;
	char isSent;
	guint32 numPackets;
	guint32 totalData;
	guint32 totalDataNew;
	guint32 snapTraffic;
	struct timeval lastPacket;
	gpointer visual;
} NetInfo;


NetStat* NetStatCreate( ip* addr );
void NetStatDestroy( NetStat* );
void NetStatForget( NetStat*, struct node* );
int NetStatProcess( NetStat* ns, struct node*, GTree* ni, ip*, struct timeval*, guint32, char isSent );
int NetStatDisplayInfo( NetStat* ns );
void NetStatUpdate( NetStat*, struct timeval* );

NetInfo* FindNetInfo( GTree* infoTree, ip* key );
NetInfo* CreateNetInfo( ip* addr, struct node*, char isSent );
int NetInfoDestroy( gpointer unused1, NetInfo* ni, gpointer unused2 );
int NetInfoForget( gpointer unused, NetInfo* ni, struct node* f );
int NetInfoDisplayInfo( gpointer, gpointer, gpointer );
gint NetInfoCompare( gconstpointer k1, gconstpointer k2 );
guint32 NetInfoKey( NetInfo* ni );
int NetInfoUpdate( gpointer, NetInfo* netInfo, struct timeval* );

int NetStatProcessSend( NetStat* ns, struct node* n, ip* dest, struct timeval*, guint32 );
int NetStatProcessReceive( NetStat* ns, struct node* n, ip* source, struct timeval*, guint32 );


#endif
