#ifndef NODE_H
#define NODE_H


#include <glib.h>
#include "wired.h"
#include "netstat.h"


typedef struct node
{	ip addr[4];
	NetStat* nodeStats;
	gpointer visual;
} Node;


int PrintAllNodes();
Node* CreateNode( ip* addr );
void NodeDestroy( Node* n );
int NodeForget( gpointer unused, Node* n, Node* f );
Node* FindNode( ip* addr );
Node* AddNewIP( ip* addr );
int AddNode( Node* new );
int NodeKey( Node* n );
int NodeCompare( Node* n1, Node* n2 );
int NodeProcessData( Node* n, ip* source, ip* dest, struct timeval*, guint32 );
void NodeDisplayInfo( WiredInterface* wi );
int NodeDisplayNodeInfo( gpointer, gpointer, gpointer );
void NodeUpdate( WiredInterface* wi, struct timeval* current );
int NodeUpdateNode( gpointer unused1, Node* n, struct timeval* current );
void NodeQueueDestroy( Node* );
void NodeProcessDestroyed();


#endif
