#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <glib.h>
#include <sys/time.h>
#include <unistd.h>

#include "config.h"
#include "wired.h"
#include "gtkdisplay.h"
#include "gldisplay.h"
#include "node.h"


/* config variables */
struct timeval gWiredTime;
guint32 gAverageTime = 500;
float gNodeTimeoutTime = 15000.0;
float gLinkTimeoutTime = 3000.0;
int gGLUpdateTime = 50;
extern int gShowNames;


void ProcessWired( int argc, char** argv )
{	int n;
	GMainLoop* loop = g_main_new( 0 );
	if( ! (WiredInterfaceCreateEnabled( 0 )) )
		return;
	gettimeofday( &gWiredTime, 0 );
	g_timeout_add( gAverageTime, (GSourceFunc) WiredInterfaceUpdateAll, 0 );
	DEBUG(1) g_timeout_add( 2000, (GSourceFunc) PrintAllNodes, 0 );
	InitGtk( argc, argv );
}


void SetOptions( int argc, char** argv )
{	int c;
	extern char* optarg;

	while( (c = getopt( argc, argv, "n:l:g:a:s" )) != EOF )
	{	switch( c )
		{	case 'n':
				gNodeTimeoutTime = (float) atof( optarg );
				break;
			case 'l':
				gLinkTimeoutTime = (float) atof( optarg );
				break;
			case 'g':
				gGLUpdateTime = atol( optarg );
				break;
			case 'a':
				gAverageTime = atol( optarg );
				break;
			case 's':
				gShowNames = -1;
				break;
		}
	}
}


int main( int argc, char** argv )
{	SetOptions( argc, argv );
	srand48( (long int) time( NULL ) );
	srand( (unsigned) time( NULL ) );
	ProcessWired( argc, argv );
	return 0;
}
